/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_DATA_BINARY_H
#define SQLSYNC_DATA_BINARY_H

#include "data_types/sqlsync_data_type.h"

#define INHERIT_binary_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_OBJECT_binary_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          uint8 *data; \
          uint32 length; \
          uint32 reserved_length;


#define INHERIT_FUNCTIONS_binary_elem(type)

DEFINE_INTERFACE_STRUCT(binary_elem);
DEFINE_INTERFACE(binary_elem);

#define INHERIT_bit_elem(type) \
          INHERIT_binary_elem(type)

#define INHERIT_OBJECT_bit_elem(type) \
          INHERIT_OBJECT_binary_elem(type); \
          uint32 max_size;

#define INHERIT_FUNCTIONS_bit_elem(type)

DEFINE_INTERFACE_STRUCT(bit_elem);
DEFINE_INTERFACE(bit_elem);


c_binary_elem_ptr c_binary_elem_empty ();

c_binary_elem_ptr c_binary_elem_copy (c_binary_elem_ptr data);

void c_binary_elem_free (c_binary_elem_ptr data);

SQLSYNC_RETURN
c_binary_elem_append_reserve (c_binary_elem_ptr elem, uint32 length);

int32 c_binary_elem_cmp (c_binary_elem_ptr src, c_binary_elem_ptr dst);

c_bit_elem_ptr c_bit_elem_empty ();

c_bit_elem_ptr c_bit_elem_copy (c_bit_elem_ptr data);

void c_bit_elem_free (c_bit_elem_ptr data);

int32 c_bit_elem_cmp (c_bit_elem_ptr src, c_bit_elem_ptr dst);

#endif /* SQLSYNC_DATA_BINARY_H */

