/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_DATA_GRID_H
#define SQLSYNC_DATA_GRID_H

#include "data_types/sqlsync_data_vector.h"
#include "data_types/sqlsync_data_vector_misc.h"

/* grid data */
#define INHERIT_grid_data(type) \
          INHERIT_vector_data(type)

#define INHERIT_OBJECT_grid_data(type) \
          INHERIT_OBJECT_vector_data(type); \


#define INHERIT_FUNCTIONS_grid_data(type) \
          INHERIT_FUNCTIONS_vector_data(type)

DEFINE_INTERFACE_STRUCT(grid_data);
DEFINE_INTERFACE(grid_data);



#define c_grid_data_init(size) (c_grid_data_ptr)c_vector_data_init (size)
#define c_grid_data_add(container, elem, pos) (c_vector_data_ptr)c_vector_data_add((c_vector_data_ptr)container, (c_data_elem_ptr)(elem), pos)
#define c_grid_data_add_last_copy(container, elem)(c_vector_data_ptr) c_vector_data_add_last_copy ((c_vector_data_ptr)container, (c_data_elem_ptr)(elem))
#define c_grid_data_add_last(container, elem) (c_vector_data_ptr)c_vector_data_add_last ((c_vector_data_ptr)container, (c_data_elem_ptr)(elem))
#define c_grid_data_pos(container, pos) (c_vector_data_ptr)c_vector_data_pos((c_vector_data_ptr)container, pos)
#define c_grid_data_destroy(container) c_vector_data_destroy((c_vector_data_ptr)container)
#define c_grid_data_delete(container, pos) c_vector_data_delete ((c_vector_data_ptr)container, pos)
#define c_grid_data_size(container) c_vector_data_size ((c_vector_data_ptr)(container))
#define c_grid_data_all_elems(container, one_elem_f, user) c_vector_data_all_elems ((c_vector_data_ptr)(container), one_elem_f, user)


SQLSYNC_RETURN c_grid_data_sort_by_primary_keys_pos (c_grid_data_ptr grid, c_vector_int32_ptr primary_keys_pos);

SQLSYNC_RETURN c_grid_data_sort (c_grid_data_ptr grid, c_vector_int32_ptr positions);

SQLSYNC_RETURN c_grid_data_sort_by_all (c_grid_data_ptr grid);


#endif /* SQLSYNC_DATA_GRID_H */

