/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_DATA_MISC_H
#define SQLSYNC_DATA_MISC_H

#include "data_types/sqlsync_data_type.h"
#include "data_types/sqlsync_data_string.h"
#include "data_types/sqlsync_data_vector.h"
#include "data_types/sqlsync_data_grid.h"

#include "sqlsync_user_notification.h"



/* BOOL */
#define INHERIT_OBJECT_bool_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          uint16 value;

#define INHERIT_bool_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_bool_elem(type)

DEFINE_INTERFACE_STRUCT(bool_elem);
DEFINE_INTERFACE(bool_elem);

c_bool_elem_ptr c_bool_elem_empty ();
void c_bool_elem_free (c_bool_elem_ptr data);
c_bool_elem_ptr c_bool_elem_copy (c_bool_elem_ptr data);
int32 c_bool_elem_cmp (c_bool_elem_ptr src, c_bool_elem_ptr dst);
c_bool_elem_Vtbl * c_bool_elem_create_Vtbl(uint32 vtbl_size);



#define INHERIT_guid_elem(type) \
          INHERIT_data_elem(type)

typedef struct
{
    uint32 Data1;
    uint16 Data2;
    uint16 Data3;
    uint8 Data4[ 8 ];
} odbc_guid_struct;

#define INHERIT_OBJECT_guid_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          odbc_guid_struct guid;

#define INHERIT_FUNCTIONS_guid_elem(type)

DEFINE_INTERFACE_STRUCT(guid_elem);
DEFINE_INTERFACE(guid_elem);


c_guid_elem_ptr c_guid_elem_empty();

void c_guid_elem_free(c_guid_elem_ptr elem);

c_guid_elem_ptr c_guid_elem_copy(c_guid_elem_ptr elem);

int32 c_guid_elem_cmp(c_guid_elem_ptr src, c_guid_elem_ptr dst);

c_guid_elem_Vtbl * c_guid_elem_create_Vtbl(uint32 vtbl_size);


#define INHERIT_column_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_OBJECT_column_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          c_string_elem_ptr column; \
          uint32 max_length;            /*!<Maximum length that column in table can store */ \
          int16 data_type;              /*!<Compatible with SQLSMALLINT */ \
          int8 use_operator;


#define INHERIT_FUNCTIONS_column_elem(type)

DEFINE_INTERFACE_STRUCT(column_elem);
DEFINE_INTERFACE(column_elem);


c_column_elem_ptr c_column_elem_copy(c_column_elem_ptr data);

void c_column_elem_free(c_column_elem_ptr data);

int32 c_column_elem_cmp (c_column_elem_ptr src, c_column_elem_ptr dst);

c_column_elem_ptr c_column_elem_empty ();

c_column_elem_ptr c_column_elem_create (c_string_elem_ptr name, uint32 max_size, 
                                        uint32 data_type, int8 use_operator);


/* columns grid */
#define INHERIT_grid_columns(type) \
          INHERIT_grid_data(type)

#define INHERIT_OBJECT_grid_columns(type) \
          INHERIT_OBJECT_grid_data(type); \


#define INHERIT_FUNCTIONS_grid_columns(type) \
          INHERIT_FUNCTIONS_grid_data(type)

DEFINE_INTERFACE_STRUCT(grid_columns);
DEFINE_INTERFACE(grid_columns);

#define c_grid_columns_init(size) (c_grid_columns_ptr)c_grid_data_init (size)
#define c_grid_columns_pos(container, pos) (c_vector_columns_ptr)c_grid_data_pos ((c_grid_data_ptr)(container), pos)
#define c_grid_columns_size(container) c_grid_data_size ((c_grid_data_ptr)(container))
#define c_grid_columns_add(container, elem, pos) c_grid_data_add ((c_grid_data_ptr)(container), (c_data_elem_ptr)elem, pos)
#define c_grid_columns_add_last(container, elem) c_grid_data_add_last ((c_grid_data_ptr)(container), (c_data_elem_ptr)elem)
#define c_grid_columns_add_last_copy(container, elem) c_grid_data_add_last_copy ((c_grid_data_ptr)container, (c_data_elem_ptr)(elem))
#define c_grid_columns_destroy(container) c_grid_data_destroy ((c_grid_data_ptr)(container))
#define c_grid_columns_copy(container) (c_grid_columns_ptr)c_grid_data_copy((c_grid_data_ptr)(container))
#define c_grid_columns_all_elems(container, one_elem_f, user) c_grid_data_all_elems ((c_grid_data_ptr)(container), one_elem_f, user)
#define c_grid_columns_find(container, data, error_ptr) c_grid_data_find ((c_grid_data_ptr)container, (c_data_elem_ptr)(data), error_ptr)


/* notification elem */
#define INHERIT_notification_elem(type) \
          INHERIT_data_elem(type) \

#define INHERIT_OBJECT_notification_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          sqlsync_user_notification *f_callback; \
          void *user_ptr;


#define INHERIT_FUNCTIONS_notification_elem(type) \
          INHERIT_FUNCTIONS_data_elem(type)

DEFINE_INTERFACE_STRUCT(notification_elem);
DEFINE_INTERFACE(notification_elem);

c_notification_elem_Vtbl * c_notification_elem_create_Vtbl(uint32 vtbl_size);

c_notification_elem_Vtbl * c_notification_elem_create_Vtbl(uint32 vtbl_size);


#endif /* SQLSYNC_DATA_MISC_H */

