/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/


#include "data_types/sqlsync_data_numeric.h"

c_data_type c_uint8_elem_get_type()
{
  return c_uint8_elem_type;
}

c_uint8_elem_ptr c_uint8_elem_empty ()
{
  c_uint8_elem_ptr tmp = std_malloc(sizeof(c_uint8_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_uint8_elem_type;

  return tmp;
}

void c_uint8_elem_free (c_uint8_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_uint8_elem_ptr c_uint8_elem_copy (c_uint8_elem_ptr data)
{
  c_uint8_elem_ptr copy = c_uint8_elem_empty();
  if (data == NULL)
  {
    c_uint8_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_uint8_elem_cmp (c_uint8_elem_ptr src, c_uint8_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}

uint32 c_uint8_elem_size(c_uint8_elem_ptr elem)
{
  return sizeof(uint8);
}

void * c_uint8_elem_data(c_uint8_elem_ptr elem)
{
  return &elem->value;
}

c_uint8_elem_Vtbl * c_uint8_elem_create_Vtbl(uint32 vtbl_size)
{
  c_uint8_elem_Vtbl * vtbl = (c_uint8_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_uint8_elem_empty;
  vtbl->elem_free = c_uint8_elem_free;
  vtbl->elem_cmp = c_uint8_elem_cmp;
  vtbl->elem_copy = c_uint8_elem_copy;
  vtbl->get_type = c_uint8_elem_get_type;
  vtbl->elem_size = c_uint8_elem_size;
  vtbl->elem_data = c_uint8_elem_data;

  return vtbl;
}


c_data_type c_int8_elem_get_type()
{
  return c_int8_elem_type;
}

c_int8_elem_ptr c_int8_elem_empty ()
{
  c_int8_elem_ptr tmp = std_malloc(sizeof(c_int8_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_int8_elem_type;

  return tmp;
}

void c_int8_elem_free (c_int8_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_int8_elem_ptr c_int8_elem_copy (c_int8_elem_ptr data)
{
  c_int8_elem_ptr copy = c_int8_elem_empty();
  if (data == NULL)
  {
    c_int8_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_int8_elem_cmp (c_int8_elem_ptr src, c_int8_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}

uint32 c_int8_elem_size(c_int8_elem_ptr elem)
{
  return sizeof(int8);
}

void * c_int8_elem_data(c_int8_elem_ptr elem)
{
  return &elem->value;
}

c_int8_elem_Vtbl * c_int8_elem_create_Vtbl(uint32 vtbl_size)
{
  c_int8_elem_Vtbl * vtbl = (c_int8_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_int8_elem_empty;
  vtbl->elem_free = c_int8_elem_free;
  vtbl->elem_cmp = c_int8_elem_cmp;
  vtbl->elem_copy = c_int8_elem_copy;
  vtbl->get_type = c_int8_elem_get_type;
  vtbl->elem_size = c_int8_elem_size;
  vtbl->elem_data = c_int8_elem_data;

  return vtbl;
}


c_data_type c_uint16_elem_get_type()
{
  return c_uint16_elem_type;
}

c_uint16_elem_ptr c_uint16_elem_empty ()
{
  c_uint16_elem_ptr tmp = std_malloc(sizeof(c_uint16_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_uint16_elem_type;

  return tmp;
}

void c_uint16_elem_free (c_uint16_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_uint16_elem_ptr c_uint16_elem_copy (c_uint16_elem_ptr data)
{
  c_uint16_elem_ptr copy = c_uint16_elem_empty();
  if (data == NULL)
  {
    c_uint16_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_uint16_elem_cmp (c_uint16_elem_ptr src, c_uint16_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}

uint32 c_uint16_elem_size(c_uint16_elem_ptr elem)
{
  return sizeof(uint16);
}

void * c_uint16_elem_data(c_uint16_elem_ptr elem)
{
  return &elem->value;
}


c_uint16_elem_Vtbl * c_uint16_elem_create_Vtbl(uint32 vtbl_size)
{
  c_uint16_elem_Vtbl * vtbl = (c_uint16_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_uint16_elem_empty;
  vtbl->elem_free = c_uint16_elem_free;
  vtbl->elem_cmp = c_uint16_elem_cmp;
  vtbl->elem_copy = c_uint16_elem_copy;
  vtbl->get_type = c_uint16_elem_get_type;
  vtbl->elem_size = c_uint16_elem_size;
  vtbl->elem_data = c_uint16_elem_data;

  return vtbl;
}


c_data_type c_int16_elem_get_type()
{
  return c_int16_elem_type;
}

c_int16_elem_ptr c_int16_elem_empty ()
{
  c_int16_elem_ptr tmp = std_malloc(sizeof(c_int16_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_int16_elem_type;

  return tmp;
}

void c_int16_elem_free (c_int16_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_int16_elem_ptr c_int16_elem_copy (c_int16_elem_ptr data)
{
  c_int16_elem_ptr copy = c_int16_elem_empty();
  if (data == NULL)
  {
    c_int16_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_int16_elem_cmp (c_int16_elem_ptr src, c_int16_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}

uint32 c_int16_elem_size(c_int16_elem_ptr elem)
{
  return sizeof(int16);
}

void * c_int16_elem_data(c_int16_elem_ptr elem)
{
  return &elem->value;
}


c_int16_elem_Vtbl * c_int16_elem_create_Vtbl(uint32 vtbl_size)
{
  c_int16_elem_Vtbl * vtbl = (c_int16_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_int16_elem_empty;
  vtbl->elem_free = c_int16_elem_free;
  vtbl->elem_cmp = c_int16_elem_cmp;
  vtbl->elem_copy = c_int16_elem_copy;
  vtbl->get_type = c_int16_elem_get_type;
  vtbl->elem_size = c_int16_elem_size;
  vtbl->elem_data = c_int16_elem_data;

  return vtbl;
}



c_data_type c_uint32_elem_get_type()
{
  return c_uint32_elem_type;
}

c_uint32_elem_ptr c_uint32_elem_empty ()
{
  c_uint32_elem_ptr tmp = std_malloc(sizeof(c_uint32_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_uint32_elem_type;

  return tmp;
}

void c_uint32_elem_free (c_uint32_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_uint32_elem_ptr c_uint32_elem_copy (c_uint32_elem_ptr data)
{
  c_uint32_elem_ptr copy = c_uint32_elem_empty();
  if (data == NULL)
  {
    c_uint32_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_uint32_elem_cmp (c_uint32_elem_ptr src, c_uint32_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}

uint32 c_uint32_elem_size(c_uint32_elem_ptr elem)
{
  return sizeof(uint32);
}

void * c_uint32_elem_data(c_uint32_elem_ptr elem)
{
  return &elem->value;
}


c_uint32_elem_Vtbl * c_uint32_elem_create_Vtbl(uint32 vtbl_size)
{
  c_uint32_elem_Vtbl * vtbl = (c_uint32_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_uint32_elem_empty;
  vtbl->elem_free = c_uint32_elem_free;
  vtbl->elem_cmp = c_uint32_elem_cmp;
  vtbl->elem_copy = c_uint32_elem_copy;
  vtbl->get_type = c_uint32_elem_get_type;
  vtbl->elem_size = c_uint32_elem_size;
  vtbl->elem_data = c_uint32_elem_data;

  return vtbl;
}



c_data_type c_int32_elem_get_type()
{
  return c_int32_elem_type;
}

c_int32_elem_ptr c_int32_elem_empty ()
{
  c_int32_elem_ptr tmp = std_malloc(sizeof(c_int32_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_int32_elem_type;

  return tmp;
}

void c_int32_elem_free (c_int32_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_int32_elem_ptr c_int32_elem_copy (c_int32_elem_ptr data)
{
  c_int32_elem_ptr copy = c_int32_elem_empty();
  if (data == NULL)
  {
    c_int32_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_int32_elem_cmp (c_int32_elem_ptr src, c_int32_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}

uint32 c_int32_elem_size(c_int32_elem_ptr elem)
{
  return sizeof(int32);
}

void * c_int32_elem_data(c_int32_elem_ptr elem)
{
  return &elem->value;
}

c_int32_elem_Vtbl * c_int32_elem_create_Vtbl(uint32 vtbl_size)
{
  c_int32_elem_Vtbl * vtbl = (c_int32_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_int32_elem_empty;
  vtbl->elem_free = c_int32_elem_free;
  vtbl->elem_cmp = c_int32_elem_cmp;
  vtbl->elem_copy = c_int32_elem_copy;
  vtbl->get_type = c_int32_elem_get_type;
  vtbl->elem_size = c_int32_elem_size;
  vtbl->elem_data = c_int32_elem_data;

  return vtbl;
}


c_data_type c_bigint_elem_get_type()
{
  return c_bigint_elem_type;
}

c_bigint_elem_ptr c_bigint_elem_empty ()
{
  c_bigint_elem_ptr tmp = std_malloc (sizeof (c_bigint_elem));

  if (tmp == NULL)
    return NULL;

  std_memset (tmp, 0, sizeof (c_bigint_elem));
  tmp->_type = c_bigint_elem_type;
  return tmp;

}


int32 c_bigint_elem_cmp (c_bigint_elem_ptr src, c_bigint_elem_ptr dst)
{
  int32 ret = 0;

  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  ret = CMP_RESULT(src->bigint.hi, dst->bigint.hi);
  if (ret != 0)
    return ret;

  return CMP_RESULT(src->bigint.low, dst->bigint.low);
}

void c_bigint_elem_free (c_bigint_elem_ptr data)
{
  if (data != NULL)
    std_free (data);
}


c_bigint_elem_ptr c_bigint_elem_copy (c_bigint_elem_ptr data)
{
  c_bigint_elem_ptr elem = c_bigint_elem_empty ();

  if (elem == NULL || data == NULL)
  {
    c_bigint_elem_free (elem);
    return NULL;
  }

  std_memcpy (elem, data, sizeof (c_bigint_elem));
  return elem;
}

uint32 c_bigint_elem_size(c_bigint_elem_ptr elem)
{
  return sizeof(odbc_bigint_struct);
}

void * c_bigint_elem_data(c_bigint_elem_ptr elem)
{
  return &elem->bigint;
}

c_bigint_elem_Vtbl * c_bigint_elem_create_Vtbl(uint32 vtbl_size)
{
  c_bigint_elem_Vtbl * vtbl = (c_bigint_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_bigint_elem_empty;
  vtbl->elem_free = c_bigint_elem_free;
  vtbl->elem_cmp = c_bigint_elem_cmp;
  vtbl->elem_copy = c_bigint_elem_copy;
  vtbl->get_type = c_bigint_elem_get_type;
  vtbl->elem_size = c_bigint_elem_size;
  vtbl->elem_data = c_bigint_elem_data;

  return vtbl;
}



c_data_type c_ubigint_elem_get_type()
{
  return c_ubigint_elem_type;
}

c_ubigint_elem_ptr c_ubigint_elem_empty ()
{
  c_ubigint_elem_ptr tmp = std_malloc (sizeof (c_ubigint_elem));

  if (tmp == NULL)
    return NULL;

  std_memset (tmp, 0, sizeof (c_ubigint_elem));
  tmp->_type = c_ubigint_elem_type;
  return tmp;

}


int32 c_ubigint_elem_cmp (c_ubigint_elem_ptr src, c_ubigint_elem_ptr dst)
{
  int32 ret = 0;
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  ret = CMP_RESULT(src->ubigint.hi, dst->ubigint.hi);
  if (ret != 0)
    return ret;

  return CMP_RESULT(src->ubigint.low, dst->ubigint.low);
}


void c_ubigint_elem_free (c_ubigint_elem_ptr data)
{
  if (data != NULL)
    std_free (data);
}

c_ubigint_elem_ptr c_ubigint_elem_copy (c_ubigint_elem_ptr data)
{
  c_ubigint_elem_ptr elem = c_ubigint_elem_empty ();

  if (elem == NULL || data == NULL)
  {
    c_ubigint_elem_free (elem);
    return NULL;
  }

  std_memcpy (elem, data, sizeof (c_ubigint_elem));
  return elem;
}


uint32 c_ubigint_elem_size(c_ubigint_elem_ptr elem)
{
  return sizeof(odbc_ubigint_struct);
}

void * c_ubigint_elem_data(c_ubigint_elem_ptr elem)
{
  return &elem->ubigint;
}

c_ubigint_elem_Vtbl * c_ubigint_elem_create_Vtbl(uint32 vtbl_size)
{
  c_ubigint_elem_Vtbl * vtbl = (c_ubigint_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_ubigint_elem_empty;
  vtbl->elem_free = c_ubigint_elem_free;
  vtbl->elem_cmp = c_ubigint_elem_cmp;
  vtbl->elem_copy = c_ubigint_elem_copy;
  vtbl->get_type = c_ubigint_elem_get_type;
  vtbl->elem_size = c_ubigint_elem_size;
  vtbl->elem_data = c_ubigint_elem_data;

  return vtbl;
}


c_data_type c_float_elem_get_type()
{
  return c_float_elem_type;
}

c_float_elem_ptr c_float_elem_empty ()
{
  c_float_elem_ptr tmp = std_malloc(sizeof(c_float_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_float_elem_type;

  return tmp;
}

void c_float_elem_free (c_float_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_float_elem_ptr c_float_elem_copy (c_float_elem_ptr data)
{
  c_float_elem_ptr copy = c_float_elem_empty();
  if (data == NULL)
  {
    c_float_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_float_elem_cmp (c_float_elem_ptr src, c_float_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}


uint32 c_float_elem_size(c_float_elem_ptr elem)
{
  return sizeof(float);
}

void * c_float_elem_data(c_float_elem_ptr elem)
{
  return &elem->value;
}

c_float_elem_Vtbl * c_float_elem_create_Vtbl(uint32 vtbl_size)
{
  c_float_elem_Vtbl * vtbl = (c_float_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_float_elem_empty;
  vtbl->elem_free = c_float_elem_free;
  vtbl->elem_cmp = c_float_elem_cmp;
  vtbl->elem_copy = c_float_elem_copy;
  vtbl->get_type = c_float_elem_get_type;
  vtbl->elem_size = c_float_elem_size;
  vtbl->elem_data = c_float_elem_data;

  return vtbl;
}


c_data_type c_double_elem_get_type()
{
  return c_double_elem_type;
}

c_double_elem_ptr c_double_elem_empty ()
{
  c_double_elem_ptr tmp = std_malloc(sizeof(c_double_elem));
  if (tmp == NULL)
    return NULL;
  
  tmp->value = 0;
  tmp->_type = c_double_elem_type;

  return tmp;
}

void c_double_elem_free (c_double_elem_ptr data)
{
  if (data != NULL)
    std_free(data);
}

c_double_elem_ptr c_double_elem_copy (c_double_elem_ptr data)
{
  c_double_elem_ptr copy = c_double_elem_empty();
  if (data == NULL)
  {
    c_double_elem_free(copy);
    return NULL;
  }
  *copy = *data;
  return copy;
}

int32 c_double_elem_cmp (c_double_elem_ptr src, c_double_elem_ptr dst)
{
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  return CMP_RESULT(src->value, dst->value);
}


uint32 c_double_elem_size(c_double_elem_ptr elem)
{
  return sizeof(double);
}

void * c_double_elem_data(c_double_elem_ptr elem)
{
  return &elem->value;
}

c_double_elem_Vtbl * c_double_elem_create_Vtbl(uint32 vtbl_size)
{
  c_double_elem_Vtbl * vtbl = (c_double_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_double_elem_empty;
  vtbl->elem_free = c_double_elem_free;
  vtbl->elem_cmp = c_double_elem_cmp;
  vtbl->elem_copy = c_double_elem_copy;
  vtbl->get_type = c_double_elem_get_type;
  vtbl->elem_size = c_double_elem_size;
  vtbl->elem_data = c_double_elem_data;

  return vtbl;
}


c_data_type c_numeric_elem_get_type()
{
  return c_numeric_elem_type;
}

/* TODO */
int32 c_numeric_elem_cmp (c_numeric_elem_ptr src, c_numeric_elem_ptr dst)
{
  int32 ret = 0;
  if (src == NULL)
  {
    if (dst == NULL)
      return 0;
    else
      return -1;
  }
  else if (dst == NULL)
    return 1;

  ret = CMP_RESULT(src->numeric.sign, dst->numeric.sign);
  if (ret != 0)
    return ret;

  return std_strncmp((char*)src->numeric.val, (char*)dst->numeric.val, odbc_SQL_MAX_NUMERIC_LEN);
}

c_numeric_elem_ptr c_numeric_elem_empty ()
{
  c_numeric_elem_ptr elem = NULL;

  elem = std_malloc (sizeof (c_numeric_elem));

  if (elem == NULL)
    return NULL;

  std_memset (elem, 0, sizeof (c_numeric_elem));

  elem->_type = c_numeric_elem_type;
  return elem;
}


void c_numeric_elem_free (c_numeric_elem_ptr data)
{
  if (data != NULL)
    std_free (data);
  return;
}


c_numeric_elem_ptr c_numeric_elem_copy (c_numeric_elem_ptr data)
{
  c_numeric_elem_ptr elem = c_numeric_elem_empty ();

  if (elem == NULL || data == NULL)
  {
    c_numeric_elem_free (elem);
    return NULL;
  }

  std_memcpy (elem, data, sizeof (c_numeric_elem));
  return elem;
}


uint32 c_numeric_elem_size(c_numeric_elem_ptr elem)
{
  return sizeof(odbc_numeric_struct);
}

void * c_numeric_elem_data(c_numeric_elem_ptr elem)
{
  return &elem->numeric;
}

c_numeric_elem_Vtbl * c_numeric_elem_create_Vtbl(uint32 vtbl_size)
{
  c_numeric_elem_Vtbl * vtbl = (c_numeric_elem_Vtbl *) c_data_elem_create_Vtbl(vtbl_size);

  if (vtbl == NULL)
    return NULL;
  
  vtbl->elem_empty = c_numeric_elem_empty;
  vtbl->elem_free = c_numeric_elem_free;
  vtbl->elem_cmp = c_numeric_elem_cmp;
  vtbl->elem_copy = c_numeric_elem_copy;
  vtbl->get_type = c_numeric_elem_get_type;
  vtbl->elem_size = c_numeric_elem_size;
  vtbl->elem_data = c_numeric_elem_data;


  return vtbl;
}


SQLSYNC_RETURN c_data_is_numeric(c_data_elem_ptr data)
{
  if (data == NULL) 
      return SQLSYNC_FALSE;

  switch(data->_type)
  {
    case c_uint8_elem_type:
    case c_int8_elem_type:
    case c_uint16_elem_type:
    case c_int16_elem_type:
    case c_uint32_elem_type:
    case c_int32_elem_type:
    case c_float_elem_type:
    case c_double_elem_type:
    case c_bigint_elem_type:
    case c_ubigint_elem_type:
    case c_numeric_elem_type:
        return SQLSYNC_TRUE;
    default:
      return SQLSYNC_FALSE;
  }
  
}


