/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_DATA_NUMERIC_H
#define SQLSYNC_DATA_NUMERIC_H

#include "data_types/sqlsync_data_type.h"


/* UINT8 */
#define INHERIT_OBJECT_uint8_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          uint8 value;

#define INHERIT_uint8_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_uint8_elem(type)

DEFINE_INTERFACE_STRUCT(uint8_elem);
DEFINE_INTERFACE(uint8_elem);

c_uint8_elem_ptr c_uint8_elem_empty ();
void c_uint8_elem_free (c_uint8_elem_ptr data);
c_uint8_elem_ptr c_uint8_elem_copy (c_uint8_elem_ptr data);
int32 c_uint8_elem_cmp (c_uint8_elem_ptr src, c_uint8_elem_ptr dst);
c_uint8_elem_Vtbl * c_uint8_elem_create_Vtbl(uint32 vtbl_size);


/* INT8 */
#define INHERIT_OBJECT_int8_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          int8 value;

#define INHERIT_int8_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_int8_elem(type)

DEFINE_INTERFACE_STRUCT(int8_elem);
DEFINE_INTERFACE(int8_elem);

c_int8_elem_ptr c_int8_elem_empty ();
void c_int8_elem_free (c_int8_elem_ptr data);
c_int8_elem_ptr c_int8_elem_copy (c_int8_elem_ptr data);
int32 c_int8_elem_cmp (c_int8_elem_ptr src, c_int8_elem_ptr dst);
c_int8_elem_Vtbl * c_int8_elem_create_Vtbl(uint32 vtbl_size);



/* UINT16 */
#define INHERIT_OBJECT_uint16_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          uint16 value;

#define INHERIT_uint16_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_uint16_elem(type)

DEFINE_INTERFACE_STRUCT(uint16_elem);
DEFINE_INTERFACE(uint16_elem);

c_uint16_elem_ptr c_uint16_elem_empty ();
void c_uint16_elem_free (c_uint16_elem_ptr data);
c_uint16_elem_ptr c_uint16_elem_copy (c_uint16_elem_ptr data);
int32 c_uint16_elem_cmp (c_uint16_elem_ptr src, c_uint16_elem_ptr dst);
c_uint16_elem_Vtbl * c_uint16_elem_create_Vtbl(uint32 vtbl_size);



/* INT16 */
#define INHERIT_OBJECT_int16_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          int16 value;

#define INHERIT_int16_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_int16_elem(type)

DEFINE_INTERFACE_STRUCT(int16_elem);
DEFINE_INTERFACE(int16_elem);


c_int16_elem_ptr c_int16_elem_empty ();
void c_int16_elem_free (c_int16_elem_ptr data);
c_int16_elem_ptr c_int16_elem_copy (c_int16_elem_ptr data);
int32 c_int16_elem_cmp (c_int16_elem_ptr src, c_int16_elem_ptr dst);
c_int16_elem_Vtbl * c_int16_elem_create_Vtbl(uint32 vtbl_size);


/* UINT32 */
#define INHERIT_OBJECT_uint32_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          uint32 value;

#define INHERIT_uint32_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_uint32_elem(type)

DEFINE_INTERFACE_STRUCT(uint32_elem);
DEFINE_INTERFACE(uint32_elem);

c_uint32_elem_ptr c_uint32_elem_empty ();
void c_uint32_elem_free (c_uint32_elem_ptr data);
c_uint32_elem_ptr c_uint32_elem_copy (c_uint32_elem_ptr data);
int32 c_uint32_elem_cmp (c_uint32_elem_ptr src, c_uint32_elem_ptr dst);
c_uint32_elem_Vtbl * c_uint32_elem_create_Vtbl(uint32 vtbl_size);



/* INT32 */
#define INHERIT_OBJECT_int32_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          int32 value;

#define INHERIT_int32_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_int32_elem(type)

DEFINE_INTERFACE_STRUCT(int32_elem);
DEFINE_INTERFACE(int32_elem);

c_int32_elem_ptr c_int32_elem_empty ();
void c_int32_elem_free (c_int32_elem_ptr data);
c_int32_elem_ptr c_int32_elem_copy (c_int32_elem_ptr data);
int32 c_int32_elem_cmp (c_int32_elem_ptr src, c_int32_elem_ptr dst);
c_int32_elem_Vtbl * c_int32_elem_create_Vtbl(uint32 vtbl_size);



typedef struct
{
  uint32 hi;
  uint32 low;

} odbc_ubigint_struct;


/* UBIGINT */
#define INHERIT_OBJECT_ubigint_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          odbc_ubigint_struct ubigint;

#define INHERIT_ubigint_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_ubigint_elem(type)

DEFINE_INTERFACE_STRUCT(ubigint_elem);
DEFINE_INTERFACE(ubigint_elem);

c_ubigint_elem_ptr c_ubigint_elem_empty ();
int32 c_ubigint_elem_cmp (c_ubigint_elem_ptr src, c_ubigint_elem_ptr dst);
void c_ubigint_elem_free (c_ubigint_elem_ptr data);
c_ubigint_elem_ptr c_ubigint_elem_copy (c_ubigint_elem_ptr data);
c_ubigint_elem_Vtbl * c_ubigint_elem_create_Vtbl(uint32 vtbl_size);



typedef struct
{
  int32 hi;
  uint32 low;

} odbc_bigint_struct;



/* BIGINT */
#define INHERIT_OBJECT_bigint_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          odbc_bigint_struct bigint;

#define INHERIT_bigint_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_bigint_elem(type)

DEFINE_INTERFACE_STRUCT(bigint_elem);
DEFINE_INTERFACE(bigint_elem);

c_bigint_elem_ptr c_bigint_elem_empty ();
int32 c_bigint_elem_cmp (c_bigint_elem_ptr src, c_bigint_elem_ptr dst);
void c_bigint_elem_free (c_bigint_elem_ptr data);
c_bigint_elem_ptr c_bigint_elem_copy (c_bigint_elem_ptr data);
c_bigint_elem_Vtbl * c_bigint_elem_create_Vtbl(uint32 vtbl_size);



/* FLOAT */
#define INHERIT_OBJECT_float_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          float value;

#define INHERIT_float_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_float_elem(type)

DEFINE_INTERFACE_STRUCT(float_elem);
DEFINE_INTERFACE(float_elem);


c_float_elem_ptr c_float_elem_empty ();
void c_float_elem_free (c_float_elem_ptr data);
c_float_elem_ptr c_float_elem_copy (c_float_elem_ptr data);
int32 c_float_elem_cmp (c_float_elem_ptr src, c_float_elem_ptr dst);
c_float_elem_Vtbl * c_float_elem_create_Vtbl(uint32 vtbl_size);



/* DOUBLE */
#define INHERIT_OBJECT_double_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          double value;

#define INHERIT_double_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_double_elem(type)

DEFINE_INTERFACE_STRUCT(double_elem);
DEFINE_INTERFACE(double_elem);


c_double_elem_ptr c_double_elem_empty ();
void c_double_elem_free (c_double_elem_ptr data);
c_double_elem_ptr c_double_elem_copy (c_double_elem_ptr data);
int32 c_double_elem_cmp (c_double_elem_ptr src, c_double_elem_ptr dst);
c_double_elem_Vtbl * c_double_elem_create_Vtbl(uint32 vtbl_size);


/* NUMERIC */
#define odbc_SQL_MAX_NUMERIC_LEN		16
typedef struct
{
  uint8 precision;
  uint8 scale;
  uint8 sign;                   /* 1=pos 0=neg */
  uint8 val[odbc_SQL_MAX_NUMERIC_LEN];
} odbc_numeric_struct;

#define INHERIT_OBJECT_numeric_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          odbc_numeric_struct numeric;

#define INHERIT_numeric_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_FUNCTIONS_numeric_elem(type)

DEFINE_INTERFACE_STRUCT(numeric_elem);
DEFINE_INTERFACE(numeric_elem);

int32 c_numeric_elem_cmp (c_numeric_elem_ptr src, c_numeric_elem_ptr dst);
c_numeric_elem_ptr c_numeric_elem_empty ();
void c_numeric_elem_free (c_numeric_elem_ptr data);
c_numeric_elem_ptr c_numeric_elem_copy (c_numeric_elem_ptr data);
c_numeric_elem_Vtbl * c_numeric_elem_create_Vtbl(uint32 vtbl_size);

SQLSYNC_RETURN c_data_is_numeric(c_data_elem_ptr data);


#endif /* SQLSYNC_DATA_NUMERIC_H */

