/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_DATA_STRING_H
#define SQLSYNC_DATA_STRING_H

#include "data_types/sqlsync_data_type.h"
#include "data_types/sqlsync_data_vector.h"

#define INHERIT_string_elem(type) \
          INHERIT_data_elem(type)

#define INHERIT_OBJECT_string_elem(type) \
          INHERIT_OBJECT_data_elem(type); \
          char *string;                 /*!<String */ \
          uint32 length;                /*!<Size of string */ \
          uint32 reserved_length;       /*!<Size of reserved space */


#define INHERIT_FUNCTIONS_string_elem(type)

DEFINE_INTERFACE_STRUCT(string_elem);
DEFINE_INTERFACE(string_elem);

c_string_elem_ptr c_string_elem_empty ();

void c_string_elem_free (c_string_elem_ptr data);

SQLSYNC_RETURN
c_string_elem_append_cstring (c_string_elem_ptr elem, char *data);

SQLSYNC_RETURN
c_string_elem_append_string (c_string_elem_ptr elem, c_string_elem_ptr append);

c_string_elem_ptr c_string_elem_copy (c_string_elem_ptr data);

void c_string_elem_make_upper (c_string_elem_ptr elem);

int32 c_string_elem_strip_lspaces(c_string_elem_ptr src);

int32 c_string_elem_cmp (c_string_elem_ptr src, c_string_elem_ptr dst);

int8 c_string_elem_icmp (c_string_elem_ptr src, c_string_elem_ptr dst);

int8 c_string_elem_ncmp (c_string_elem_ptr src, c_string_elem_ptr dst, uint32 max_pos);

SQLSYNC_RETURN
c_string_elem_append (c_string_elem_ptr elem, char *data, uint32 length);

c_string_elem_ptr c_string_elem_reserve (uint32 length);

SQLSYNC_RETURN c_string_elem_append_reserve (c_string_elem_ptr elem, uint32 length);


/* string vector */
#define INHERIT_vector_strings(type) \
          INHERIT_vector_data(type)

#define INHERIT_OBJECT_vector_strings(type) \
          INHERIT_OBJECT_vector_data(type); \


#define INHERIT_FUNCTIONS_vector_strings(type) \
          INHERIT_FUNCTIONS_vector_data(type)

DEFINE_INTERFACE_STRUCT(vector_strings);
DEFINE_INTERFACE(vector_strings);

SQLSYNC_RETURN c_vector_strings_append_data (c_vector_strings_ptr container, 
                                             uint32 pos, char *data, uint32 length);

#define c_vector_strings_init(size) (c_vector_strings_ptr)c_vector_data_init (size)
#define c_vector_strings_add(container, elem, pos) (c_string_elem_ptr)c_vector_data_add((c_vector_data_ptr)container, (c_data_elem_ptr)(elem), pos)
#define c_vector_strings_add_last_copy(container, elem)(c_string_elem_ptr) c_vector_data_add_last_copy ((c_vector_data_ptr)container, (c_data_elem_ptr)(elem))
#define c_vector_strings_add_last(container, elem) (c_string_elem_ptr)c_vector_data_add_last ((c_vector_data_ptr)container, (c_data_elem_ptr)(elem))
#define c_vector_strings_pos(container, pos) (c_string_elem_ptr)c_vector_data_pos((c_vector_data_ptr)container, pos)
#define c_vector_strings_destroy(container) c_vector_data_destroy((c_vector_data_ptr)container)
#define c_vector_strings_delete(container, pos) c_vector_data_delete ((c_vector_data_ptr)container, pos)
#define c_vector_strings_size(container) c_vector_data_size ((c_vector_data_ptr)(container))

#endif /* SQLSYNC_DATA_STRING_H */
