/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_DATA_VECTOR_MISC_H
#define SQLSYNC_DATA_VECTOR_MISC_H

#include "data_types/sqlsync_data_type.h"
#include "data_types/sqlsync_data_vector.h"


/* int32 vector */
#define INHERIT_vector_int32(type) \
          INHERIT_vector_data(type)

#define INHERIT_OBJECT_vector_int32(type) \
          INHERIT_OBJECT_vector_data(type); \


#define INHERIT_FUNCTIONS_vector_int32(type) \
          INHERIT_FUNCTIONS_vector_data(type)

DEFINE_INTERFACE_STRUCT(vector_int32);
DEFINE_INTERFACE(vector_int32);

#define c_vector_int32_init(size) (c_vector_int32_ptr)c_vector_data_init (size)
#define c_vector_int32_pos(container, pos) (c_int32_elem_ptr)c_vector_data_pos ((c_vector_data_ptr)(container), pos)
#define c_vector_int32_size(container) c_vector_data_size ((c_vector_data_ptr)(container))
#define c_vector_int32_add_last(container, elem) c_vector_data_add_last ((c_vector_data_ptr)(container), (c_data_elem_ptr)elem)
#define c_vector_int32_add_last_copy(container, elem) c_vector_data_add_last_copy ((c_vector_data_ptr)container, (c_data_elem_ptr)(elem))
#define c_vector_int32_destroy(container) c_vector_data_destroy ((c_vector_data_ptr)(container))
#define c_vector_int32_copy(container) (c_vector_int32_ptr)c_vector_data_copy((c_vector_data_ptr)(container))
#define c_vector_int32_all_elems(container, one_elem_f, user) c_vector_data_all_elems ((c_vector_data_ptr)(container), one_elem_f, user)
#define c_vector_int32_find(container, data, error_ptr) c_vector_data_find ((c_vector_data_ptr)container, (c_data_elem_ptr)(data), error_ptr)

/* columns vector */
#define INHERIT_vector_columns(type) \
          INHERIT_vector_data(type)

#define INHERIT_OBJECT_vector_columns(type) \
          INHERIT_OBJECT_vector_data(type); \


#define INHERIT_FUNCTIONS_vector_columns(type) \
          INHERIT_FUNCTIONS_vector_data(type)

DEFINE_INTERFACE_STRUCT(vector_columns);
DEFINE_INTERFACE(vector_columns);

#define c_vector_columns_init(size) (c_vector_columns_ptr)c_vector_data_init (size)
#define c_vector_columns_pos(container, pos) (c_column_elem_ptr)c_vector_data_pos ((c_vector_data_ptr)(container), pos)
#define c_vector_columns_size(container) c_vector_data_size ((c_vector_data_ptr)(container))
#define c_vector_columns_add_last(container, elem) c_vector_data_add_last ((c_vector_data_ptr)(container), (c_data_elem_ptr)elem)
#define c_vector_columns_add_last_copy(container, elem) c_vector_data_add_last_copy ((c_vector_data_ptr)container, (c_data_elem_ptr)(elem))
#define c_vector_columns_destroy(container) c_vector_data_destroy ((c_vector_data_ptr)(container))
#define c_vector_columns_copy(container) (c_vector_columns_ptr)c_vector_data_copy((c_vector_data_ptr)(container))
#define c_vector_columns_all_elems(container, one_elem_f, user) c_vector_data_all_elems ((c_vector_data_ptr)(container), one_elem_f, user)
#define c_vector_columns_find(container, data, error_ptr) c_vector_data_find ((c_vector_data_ptr)container, (c_data_elem_ptr)(data), error_ptr)

#endif /* SQLSYNC_DATA_VECTOR_MISC_H */

