/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_DEFAULT_IMPL_H
#define SQLSYNC_DEFAULT_IMPL_H

#include "server/sqlsync_sqlserver.h"
#include "server/sqlsync_sqlserver_data_types.h"

void sqlsync_create_stmt (sqlsync_sqlserver * server);

SQLSYNC_RETURN sqlsync_get_data (void *hstmt_ptr, uint8 nr_column, sqlsync_sqlserver_data_type data_type, uint32 max_data_size, c_data_elem_ptr * _elem);


SQLSYNC_RETURN sqlsync_sqlserver_default_get_data (void *hstmt_ptr, uint8 nr_column, sqlsync_sqlserver_data_type data_type, c_data_elem_ptr * _elem);


c_vector_strings_ptr
sqlsync_sqlserver_get_common_tables (sqlsync_sqlserver * server, c_vector_strings_ptr tables);

SQLSYNC_RETURN sqlsync_sqlserver_default_check_table ( /*@null@ */ sqlsync_sqlserver * server,
                                                    c_string_elem_ptr table);

/**
 * Function returns available (not system) tables from database
 * @param info_ptr Pointer to main structure
 * @param nr_server Which server (SRC or DST)
 * 
 * @return c_data Pointer to structure which contains list of
 *         tables
 */
c_vector_strings_ptr sqlsync_sqlserver_default_get_tables (sqlsync_sqlserver * server);


/**
 * Function returns columns from table
 * @param info_ptr Pointer to main structure
 * @param nr_server Which server (SRC or DST)
 * @param table From which table column info should be received
 * 
 * @return c_data Pointer to structure which contains list of
 *         columns
 */
c_vector_columns_ptr sqlsync_sqlserver_default_get_columns (sqlsync_sqlserver * server,
                                                      c_string_elem_ptr table);


c_vector_columns_ptr
sqlsync_sqlserver_default_old_get_primary_keys (sqlsync_sqlserver * server, c_string_elem_ptr table);

c_vector_columns_ptr sqlsync_sqlserver_default_get_primary_keys (sqlsync_sqlserver * server,
                                                          c_string_elem_ptr table);

#endif /* SQLSYNC_DEFAULT_IMPL_H */


