/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_QUERY_H
#define SQLSYNC_QUERY_H

#include "sqlsync_def.h"

#include "data_types/sqlsync_data_string.h"

#include "server/sqlsync_sqlserver.h"

/**
*   Executes SQL query
*   @param info_ptr Pointer to main structure
*   @param nr_server Which server (SRC or DST) should receive
*                    query
*   @param query Query string
*   @return Returns SQLSYNC_FAILED_QUERY if something went wrong
*   if pointers are null function returns SQLSYNC_FAILED_NULL
*           otherwise SQLSYNC_SUCCESS
**/
SQLSYNC_RETURN sqlsync_exec_query (sqlsync_sqlserver * server,
                                   /*@null@ */ c_string_elem_ptr query);

/**
*   Executes SQL queries from file
*   @param info_ptr Pointer to main structure
*   @param nr_server Which server (SRC or DST) should receive
*                    query
*   @param name Filename with queries to run
*   @return Returns SQLSYNC_FAILED_QUERY if something went wrong
*   if pointers are null function returns SQLSYNC_FAILED_NULL
*           otherwise SQLSYNC_SUCCESS
**/
SQLSYNC_RETURN sqlsync_execute_query_file (sqlsync_sqlserver * server, c_string_elem_ptr name);

#endif /* SQLSYNC_QUERY_H */
