/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_SQLSERVER_DATA_TYPES_H
#define SQLSYNC_SQLSERVER_DATA_TYPES_H

#include "sqlsync_def.h"
#include "data_types/sqlsync_data_type.h"

typedef enum _sqlsync_sqlserver_data_type
{
  SQLSYNC_SQLSERVER_DATA_UNKNOWN,
  SQLSYNC_SQLSERVER_DATA_CHAR,
  SQLSYNC_SQLSERVER_DATA_WCHAR,
  
  SQLSYNC_SQLSERVER_DATA_BLOB,
  SQLSYNC_SQLSERVER_DATA_CBLOB,

  SQLSYNC_SQLSERVER_DATA_DATE,
  SQLSYNC_SQLSERVER_DATA_DATETIME,
  SQLSYNC_SQLSERVER_DATA_TIME,
  SQLSYNC_SQLSERVER_DATA_TIME_TZ,
  SQLSYNC_SQLSERVER_DATA_YEAR,
  SQLSYNC_SQLSERVER_DATA_TIMESTAMP,
  SQLSYNC_SQLSERVER_DATA_TIMESTAMP_TZ,
  SQLSYNC_SQLSERVER_DATA_INTERVAL,

  SQLSYNC_SQLSERVER_DATA_BINARY,
  SQLSYNC_SQLSERVER_DATA_BIT,

  SQLSYNC_SQLSERVER_DATA_UTINYINT,
  SQLSYNC_SQLSERVER_DATA_TINYINT,
  SQLSYNC_SQLSERVER_DATA_USMALLINT,
  SQLSYNC_SQLSERVER_DATA_SMALLINT,
  SQLSYNC_SQLSERVER_DATA_UMEDIUMINT,
  SQLSYNC_SQLSERVER_DATA_MEDIUMINT,
  SQLSYNC_SQLSERVER_DATA_UINTEGER,
  SQLSYNC_SQLSERVER_DATA_INTEGER,
  SQLSYNC_SQLSERVER_DATA_UBIGINT,
  SQLSYNC_SQLSERVER_DATA_BIGINT,
  SQLSYNC_SQLSERVER_DATA_UNUMERIC,
  SQLSYNC_SQLSERVER_DATA_NUMERIC,

  SQLSYNC_SQLSERVER_DATA_FLOAT,
  SQLSYNC_SQLSERVER_DATA_DOUBLE,

  SQLSYNC_SQLSERVER_DATA_XML,

  SQLSYNC_SQLSERVER_DATA_BOOL,

  SQLSYNC_SQLSERVER_DATA_GUID,

  SQLSYNC_SQLSERVER_DATA_MONEY,

} sqlsync_sqlserver_data_type;

int16 sqlsync_sqlserver_map_to_odbc(sqlsync_sqlserver_data_type data_type);

void sqlsync_sqlserver_type_size(sqlsync_sqlserver_data_type data_type, uint32 * size);

c_data_elem_ptr sqlsync_sqlserver_create_data(sqlsync_sqlserver_data_type type, uint32 max_size);

#endif /* SQLSYNC_SQLSERVER_DATA_TYPES_H */


