/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_QUERY_DATA_H
#define SQLSYNC_QUERY_DATA_H

#include "data_types/sqlsync_data_type.h"

c_string_elem_ptr sqlsync_create_INSERT_query (sqlsync_server_type type,
                                               c_string_elem_ptr table,
                                               c_vector_columns_ptr columns,
                                               c_vector_data_ptr values);


c_string_elem_ptr sqlsync_create_UPDATE_query (sqlsync_server_type type,
                                               c_string_elem_ptr table,
                                               c_vector_columns_ptr set_columns,
                                               c_vector_data_ptr set_values,
                                               c_vector_columns_ptr where_columns,
                                               c_vector_data_ptr where_values);

c_string_elem_ptr sqlsync_create_DELETE_query (sqlsync_server_type type,
                                               c_string_elem_ptr table,
                                               c_vector_columns_ptr columns,
                                               c_vector_data_ptr values);


c_string_elem_ptr sqlsync_create_SELECT_query (sqlsync_server_type type,
                                               c_string_elem_ptr table,
                                               c_vector_columns_ptr columns);


#endif /* SQLSYNC_QUERY_DATA_H */
