/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_SYNCHRONIZATION_H
#define SQLSYNC_SYNCHRONIZATION_H

#include "sqlsync_compare_results.h"

#include "sqlsync_user_internal.h"

SQLSYNC_RETURN sqlsync_create_synchronization_queries (c_cmp_ptr container, SQLSYNC_RETURN save);

SQLSYNC_RETURN
sqlsync_create_run_synchronization_queries (sqlsync_info_ptr info_ptr, c_cmp_ptr container);

SQLSYNC_RETURN sqlsync_query_create_INSERT_queries (c_cmp_ptr container, SQLSYNC_RETURN save);

SQLSYNC_RETURN sqlsync_query_create_DELETE_queries (c_cmp_ptr container, SQLSYNC_RETURN save);

SQLSYNC_RETURN sqlsync_query_create_UPDATE_queries (c_cmp_ptr container, SQLSYNC_RETURN save);

#ifdef SQLSYNC_DEPRECATED
/**
 * Function prints synchronization queries
 * @param container Pointer to the structure which contains
 *                  information about table
 * 
 * @return SQLSYNC_RETURN Returns SQLSYNC_FAILED_NULL is pointer
 *         were null otherwise SQLSYNC_SUCCESS is returned
 */

SQLSYNC_RETURN sqlsync_print_synchronization_queries (c_cmp_ptr container);

/**
 * Function runs synchronization queries
 * @param info Pointer to the main structure
 * @param container Pointer to the structure which contains
 *                  information about table
 * 
 * @return SQLSYNC_RETURN Returns SQLSYNC_FAILED_NULL is pointer
 *         were null otherwise SQLSYNC_SUCCESS is returned
 */
SQLSYNC_RETURN sqlsync_run_synchronization_queries (sqlsync_info_ptr info_ptr, c_cmp_ptr container);

#endif

/**
 * Function prints table summary (statistics, different missing
 * additional rows etc)
 * @param container Pointer to the structure which contains
 *                  information about table
 * 
 * @return SQLSYNC_RETURN Returns SQLSYNC_FAILED_NULL is pointer
 *         were null otherwise SQLSYNC_SUCCESS is returned
 */
SQLSYNC_RETURN sqlsync_send_table_summary (c_cmp_ptr container);

SQLSYNC_RETURN sqlsync_send_user_notification_synchronization_handler (sqlsync_user_message message,
                                                                       sqlsync_user_data * data);

/**
 * Function creates synchronization queries
 * @param info_ptr Pointer to main structure
 * @param table Table name
 * @param columns List of columns
 * @return SQLSYNC_RETURN Returns SQLSYNC_FAILED_NULL is pointer
 *         were null otherwise SQLSYNC_SUCCESS is returned
 */


SQLSYNC_RETURN sqlsync_run_SELECT_queries (sqlsync_info_ptr info_ptr, 
                                           sqlsync_table_columns * tc_src, sqlsync_table_columns * tc_dst);


#endif /* SQLSYNC_SYNCHRONIZATION_H */
