/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_USER_NOTIFICATION_H
#define SQLSYNC_USER_NOTIFICATION_H

#include "data_types/sqlsync_data_string.h"
#include "data_types/sqlsync_data_vector_misc.h"

typedef enum
{
  SQLSYNC_USER_ERROR_MESSAGE,
  SQLSYNC_USER_INFO_MESSAGE,
  SQLSYNC_USER_DSN_INFO,
  SQLSYNC_USER_SUMMARY,
  SQLSYNC_USER_SUMMARY_DIFF,
  SQLSYNC_USER_SUMMARY_MISS,
  SQLSYNC_USER_SUMMARY_ADD,
  SQLSYNC_USER_SUMMARY_END,

  SQLSYNC_USER_CONNECTION_FAILED,

  SQLSYNC_USER_COMPARE_TABLES_BEGIN,
  SQLSYNC_USER_COMPARE_TABLES_END,

  SQLSYNC_USER_DIFF_SRC_ROW_ELEM,
  SQLSYNC_USER_DIFF_DST_ROW_ELEM,
  SQLSYNC_USER_MISS_ROW_ELEM,
  SQLSYNC_USER_ADD_ROW_ELEM,

  SQLSYNC_USER_CREATE_DIFF_QUERY,
  SQLSYNC_USER_CREATE_MISS_QUERY,
  SQLSYNC_USER_CREATE_ADD_QUERY,

  SQLSYNC_USER_CREATE_QUERIES_BEGIN,
  SQLSYNC_USER_CREATE_DIFF_QUERIES,
  SQLSYNC_USER_CREATE_MISS_QUERIES,
  SQLSYNC_USER_CREATE_ADD_QUERIES,
  SQLSYNC_USER_CREATE_QUERIES_END,

  SQLSYNC_USER_RUN_QUERIES_BEGIN,
  SQLSYNC_USER_RUN_DIFF_QUERIES,
  SQLSYNC_USER_RUN_MISS_QUERIES,
  SQLSYNC_USER_RUN_ADD_QUERIES,
  SQLSYNC_USER_RUN_QUERIES_ERROR,
  SQLSYNC_USER_RUN_QUERIES_END,

  SQLSYNC_USER_RUN_DIFF_QUERY,
  SQLSYNC_USER_RUN_MISS_QUERY,
  SQLSYNC_USER_RUN_ADD_QUERY,


} sqlsync_user_message;


typedef struct
{
  void *user_ptr;
  union
  {
    c_string_elem_ptr string;

    struct
    {
      c_string_elem_ptr elem;
      uint32 position;
    } row_elem;

    struct
    {
      c_string_elem_ptr query;
      uint32 query_idx;
      uint32 nr_of_queries;
    } query_info;

    struct
    {
      c_string_elem_ptr table;
      uint32 nr_columns;
      c_vector_columns_ptr columns;
      uint32 nr_equal_rows;
      uint32 nr_diff_rows;
      uint32 nr_miss_rows;
      uint32 nr_add_rows;
    } summary;

    struct
    {
      c_string_elem_ptr dsn;
      c_string_elem_ptr description;
    } dsn_info;

  } user_data;

} sqlsync_user_data;

typedef SQLSYNC_RETURN sqlsync_user_notification (sqlsync_user_message message,
                                                  sqlsync_user_data * data);

void sqlsync_user_notification_register (sqlsync_user_notification f_callback, void *user_ptr);

#endif /* SQLSYNC_USER_NOTIFICATION_H */
