/****************************************************************************
**
** SqlSync - Comparing and synchronizing data in SQL databases
** Copyright (c) 2006-2008, SILVERCODERS(R)
** http://silvercoders.com
**
** Project homepage: http://silvercoders.com/index.php?page=sqlsync
** Project authors:  Pawel 'pawel_p' Pluciennik
**
** This program may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file COPYING.GPL included in the
** packaging of this file.
**
** Please remember that any attempt to workaround the GNU General Public
** License using wrappers, pipes, client/server protocols, and so on
** is considered as license violation. If your program, published on license
** other than GNU General Public License version 2, calls some part of this
** code directly or indirectly, you have to buy commercial license.
** If you do not like our point of view, simply do not use the product.
**
** Licensees holding valid commercial license for this product
** may use this file in accordance with the license published by
** SILVERCODERS and appearing in the file COPYING.COM
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
*****************************************************************************/

#ifndef SQLSYNC_HELP_H
#define SQLSYNC_HELP_H

char sqlsync_help[] = {
  "\nNAME\n"
    "\tSQLSYNC - 1.0.0-rc1\n"
    "\n"
    "SYNOPSIS\n"
    "\t[--src-dsn src_dsn] [--src-user user_src] [--src-password src_pass]\n"
    "\t[--dst-dsn dst_dsn] [--dst-user user_dst] [--dst-password dst_pass]\n"
    "\t[--query-file]\n"
    "\t[--silent]\n"
    "\t[--show-summary] [--show-queries] [--run-queries]\n"
    "\t[--ignore-case-sensitive]\n"
    "\t[--tables]\n"
    "\n"
    "OPTIONS\n"
    "\t--src-dsn\n"
    "\t\tSource DSN.\n\n"
    "\t--src-user\n"
    "\t\tUser for source DSN.\n\n"
    "\t--src-password\n"
    "\t\tPassword for source DSN.\n"
    "\t\tIf password is empty skip this option.\n\n"
    "\t--dst-dsn\n"
    "\t\tDestination DSN.\n\n"
    "\t--dst-user\n"
    "\t\tUser for destination DSN.\n\n"
    "\t--dst-password\n"
    "\t\tPassword for destination DSN.\n\n"
    "\t--silent\n"
    "\t\tDisables messages.\n\n"
    "\t--ignore-case-sensitive\n"
    "\t\tIgnore table and columns case sensitive\n"
    "\t--tables\n"
    "\t\tOption to pass list of tables and columns to synchronize.\n"
    "\t\tExample: table1[column1,column2],table2,table3[column]\n"
    "\t\tSelects table1 and column1 and column2 from that table,\n"
    "\t\talso table2 is selected with all columns from that table\n"
    "\t\tand table3 with one column is selected.\n"
    "\t\tIf this option is not used all tables and all columns are used.\n\n"
    "\t--query-file\n"
    "\t\tRuns query from file also --src-dsn parameter is obligatory.\n"
    "\t\tExample: --src-dsn my_dsn --query-file /my/query_file.sql\n\n"
    "\t--show-summary\n"
    "\t\tShows summary with informations about tables\n"
    "\t\t(missing, additional, different).\n"
    "\t\tPrints also differences between two compared tables\n\n"
    "\t--show-queries\n"
    "\t\tShow queries for destination DSN\n\n"
    "\t--run-queries\n"
    "\t\tGenerates SQL queries for destination DSN and execute them\n"
    "\n"
    "DETAILS\n"
    "\tIf password for either for source or destination DSN is empty\n"
    "\tskip respectively --src-password or --dst-password\n\n"
    "\tWhen neither --show-queries or --run-queries option is used\n"
    "\tprogram will use --show-summary by default, in other cases\n"
    "\tprogram use selected options.\n" "\n"
};

#endif /* SQLSYNC_HELP_H */
