#include <stdlib.h>

#include "data_types/sqlsync_data_converter.h"

#include "test_macros.h"
#if 0
void
test_sqlsync_data_convert_ints8 ()
{
  c_strings_elem_ptr out = NULL;
  c_uint8_elem u8 = {c_uint8_elem_type, 0};
  c_int8_elem i8 = {c_int8_elem_type, 0};

  c_strings_elem out_u8_1 = {c_strings_elem_type, "255", 3, 4 };
  c_strings_elem out_u8_2 = {c_strings_elem_type,  "0", 1, 2 };

  c_strings_elem out_i8_1 = {c_strings_elem_type,  "127", 3, 4 };
  c_strings_elem out_i8_2 = {c_strings_elem_type,  "-128", 4, 5 };



  TEST_NAME ("Test uint8");
  u8.value = 255;
  out = c_data_convert ((c_data_elem_ptr)&u8, SQLSYNC_FALSE);
  TEST ("Test if uint8 equals 255", c_strings_elem_cmp (out, &out_u8_1) == 0);
  c_strings_elem_free (out);

  u8.value = 0;
  out = c_data_convert ((c_data_elem_ptr)&u8, SQLSYNC_FALSE);
  TEST ("Test if uint8 equals 0", c_strings_elem_cmp (out, &out_u8_2) == 0);
  c_strings_elem_free (out);
  TEST_NAME_END ("Test uint8");

  TEST_NAME ("Test int8");
  
  i8.value = 127;
  out = c_data_convert ((c_data_elem_ptr)&i8, SQLSYNC_FALSE);
  TEST ("Test if int8 equals 127", c_strings_elem_cmp (out, &out_i8_1) == 0);
  c_strings_elem_free (out);

  i8.value = -128;
  out = c_data_convert ((c_data_elem_ptr)&i8, SQLSYNC_FALSE);
  TEST ("Test if int8 equals -128", c_strings_elem_cmp (out, &out_i8_2) == 0);
  c_strings_elem_free (out);

  TEST_NAME_END ("Test int8");

}


void
test_sqlsync_data_convert_ints16 ()
{
  c_strings_elem_ptr out = NULL;
  c_uint16_elem u16 = {c_uint16_elem_type, 0};
  c_int16_elem i16 = {c_int16_elem_type, 0};

  c_strings_elem out_u16_1 = {c_strings_elem_type,  "65535", 5, 6 };
  c_strings_elem out_u16_2 = {c_strings_elem_type,  "0", 1, 2 };

  c_strings_elem out_i16_1 = {c_strings_elem_type,  "32767", 5, 7 };
  c_strings_elem out_i16_2 = {c_strings_elem_type,  "-32768", 6, 7 };



  TEST_NAME ("Test uint16");

  u16.value = 65535;
  out = c_data_convert ((c_data_elem_ptr)&u16, SQLSYNC_FALSE);
  TEST ("Test if uint8 equals 65535", c_strings_elem_cmp (out, &out_u16_1) == 0);
  c_strings_elem_free (out);

  u16.value = 0;
  out = c_data_convert ((c_data_elem_ptr)&u16, SQLSYNC_FALSE);
  TEST ("Test if uint16 equals 0", c_strings_elem_cmp (out, &out_u16_2) == 0);
  c_strings_elem_free (out);
  TEST_NAME_END ("Test uint16");

  TEST_NAME ("Test int16");

  i16.value = 32767;
  out = c_data_convert ((c_data_elem_ptr)&i16, SQLSYNC_FALSE);
  TEST ("Test if int16 equals 32767", c_strings_elem_cmp (out, &out_i16_1) == 0);
  c_strings_elem_free (out);

  i16.value = -32768;
  out = c_data_convert ((c_data_elem_ptr)&i16, SQLSYNC_FALSE);
  TEST ("Test if int16 equals -32768", c_strings_elem_cmp (out, &out_i16_2) == 0);
  c_strings_elem_free (out);

  TEST_NAME_END ("Test int8");

}

#endif 
void
test_sqlsync_data_converter ()
{
#if 0
  test_sqlsync_data_convert_ints8 ();
  test_sqlsync_data_convert_ints16 ();
#endif
}
